unit Unit1;

interface
{$IFDEF Win32}
uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, TetPanel, StdCtrls, Menus, Buttons,
  Unit2, TabNotBk, ComCtrls;
{$ELSE}
uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, TetPanel, StdCtrls, Menus, Buttons,
  Unit2, TabNotBk;
{$ENDIF}
type
  TForm1 = class (TForm)
    RadioGroup1: TRadioGroup;
    MainMenu1: TMainMenu;
    TamaSi1: TMenuItem;
    stPanel1: TMenuItem;
    Tetris1: TMenuItem;
    Start1: TMenuItem;
    Pause1: TMenuItem;
    Exit1: TMenuItem;
    About2: TMenuItem;
    GroupBox10: TGroupBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn14: TBitBtn;
    RadioButton1: TRadioButton;
    RadioButton3: TRadioButton;
    GroupBox7: TGroupBox;
    BitBtn6: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    GroupBox8: TGroupBox;
    RF1: TRadioButton;
    RF2: TRadioButton;
    RF3: TRadioButton;
    RF4: TRadioButton;
    RF5: TRadioButton;
    RF6: TRadioButton;
    RF7: TRadioButton;
    Label1: TLabel;
    TabbedNotebook1: TTabbedNotebook;
    Memo1: TMemo;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    ComboBox4: TComboBox;
    ComboBox5: TComboBox;
    RadioGroup2: TRadioGroup;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    RadioButton7: TRadioButton;
    GroupBox3: TGroupBox;
    RadioButton11: TRadioButton;
    RadioButton12: TRadioButton;
    RadioButton13: TRadioButton;
    GroupBox4: TGroupBox;
    RadioButton8: TRadioButton;
    RadioButton9: TRadioButton;
    RadioButton10: TRadioButton;
    RadioButton20: TRadioButton;
    CheckBox1: TCheckBox;
    ComboBox9: TComboBox;
    ComboBox11: TComboBox;
    CheckBox4: TCheckBox;
    CheckBox6: TCheckBox;
    ComboBox25: TComboBox;
    CheckBox9: TCheckBox;
    CheckBox2: TCheckBox;
    GroupBox5: TGroupBox;
    ComboBox7: TComboBox;
    GroupBox6: TGroupBox;
    ComboBox8: TComboBox;
    CheckBox3: TCheckBox;
    Edit1: TEdit;
    Label10: TLabel;
    CheckBox10: TCheckBox;
    TetPanel1: TTetPanel;
    GroupBox1: TGroupBox;
    RadioButton2: TRadioButton;
    RadioButton14: TRadioButton;
    BitBtn7: TBitBtn;
    procedure RadioButton3Click (Sender: TObject);
    procedure RadioButton1Click (Sender: TObject);
    procedure Exit1Click (Sender: TObject);
    procedure stPanel1Click (Sender: TObject);
    procedure About2Click (Sender: TObject);
    procedure BitBtn1Click (Sender: TObject);
    procedure Start1Click (Sender: TObject);
    procedure Pause1Click (Sender: TObject);
    procedure Tetris1Click (Sender: TObject);
    procedure BitBtn2Click (Sender: TObject);
    procedure TetPanel1TetrisOver (Sender: TObject);
    procedure TetPanel1TetrisDelete (Sender: TObject);
    procedure TetPanel1TetrisContact (Sender: TObject);
    procedure FormCreate (Sender: TObject);
    procedure ComboBox2Change (Sender: TObject);
    procedure ComboBox3Change (Sender: TObject);
    procedure ComboBox4Change (Sender: TObject);
    procedure ComboBox5Change (Sender: TObject);
    procedure RadioButton4Click (Sender: TObject);
    procedure RadioButton5Click (Sender: TObject);
    procedure RadioButton6Click (Sender: TObject);
    procedure RadioButton7Click (Sender: TObject);
    procedure BitBtn3Click (Sender: TObject);
    procedure BitBtn4Click (Sender: TObject);
    procedure BitBtn5Click (Sender: TObject);
    procedure BitBtn6Click (Sender: TObject);
    procedure RadioButton8Click (Sender: TObject);
    procedure RadioButton9Click (Sender: TObject);
    procedure RadioButton10Click (Sender: TObject);
    procedure RadioButton11Click (Sender: TObject);
    procedure RadioButton12Click (Sender: TObject);
    procedure RadioButton13Click (Sender: TObject);
    procedure ComboBox7Change (Sender: TObject);
    procedure ComboBox8Change (Sender: TObject);
    procedure ComboBox9Change (Sender: TObject);
    procedure Edit1Change (Sender: TObject);
    procedure CheckBox1Click (Sender: TObject);
    procedure FormKeyDown (Sender: TObject; var Key: Word;
    Shift: TShiftState);
    procedure CheckBox2Click (Sender: TObject);
    procedure ComboBox11Change (Sender: TObject);
    procedure RF1Click (Sender: TObject);
    procedure RF7Click (Sender: TObject);
    procedure RF4Click (Sender: TObject);
    procedure RF2Click (Sender: TObject);
    procedure RF3Click (Sender: TObject);
    procedure RF5Click (Sender: TObject);
    procedure RF6Click (Sender: TObject);
    procedure CheckBox4Click (Sender: TObject);
    procedure BitBtn14Click (Sender: TObject);
    procedure RadioButton20Click (Sender: TObject);
    procedure CheckBox6Click (Sender: TObject);
    procedure ComboBox25Change (Sender: TObject);
    procedure CheckBox9Click (Sender: TObject);
    procedure CheckBox3Click (Sender: TObject);
    procedure CheckBox10Click (Sender: TObject);
    procedure TabbedNotebook1Click (Sender: TObject);
    private
    { Private declarations }
  public
  AboutBox: TAboutBox;
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
var
i, t, Tmp, ii: LongInt;

procedure TForm1.FormCreate (Sender: TObject);
var
D1,D2,D3,D4: Integer;
begin
D1:=(Screen.Height-Height) div 2;
D2:=(Screen.Width-Width) div 2;
SetBounds(D1,D2,Width,Height);
Try
  Memo1.Lines.LoadFromFile ('memo.txt');
Except
  ShowMessage ('Cannot Open memo.txt');
end;
TabbedNoteBook1.ActivePage:='sTetPanel';
for i:=0 to 7 do
Combobox3.Items:=Combobox2.Items;
Combobox4.Items:=Combobox2.Items;
Combobox5.Items:=Combobox2.Items;
for i:=1 to 10 do Combobox9.Items.Add (IntToStr (i));
for i:=6 to 48 do
begin
if i <= 24 then Combobox8.Items.Add (IntToStr (i));
Combobox7.Items.Add (IntToStr (i));
end;
TetPanel1.BStPicture:=Edit1.Text;
end;

procedure TForm1.RadioButton1Click (Sender: TObject);
begin
stPanel1.Click;
end;

procedure TForm1.RadioButton3Click (Sender: TObject);
begin
Tetris1.Click;
end;

procedure TForm1.Exit1Click (Sender: TObject);
begin
Form1.Close;
end;

procedure TForm1.stPanel1Click (Sender: TObject);
begin
RadioButton1.Checked := True;
RadioButton2.Checked := True;
TetPanel1.State := stPanel;
Start1.Enabled := False;
Pause1.Enabled := False;
BitBtn1.Enabled := False;
BitBtn2.Enabled := False;
Label1.Caption := '';
ComboBox7.Enabled := True;
ComboBox8.Enabled := True;
CheckBox4.Enabled := True;
GroupBox5.Enabled := True;
GroupBox6.Enabled := True;
with TabbedNoteBook1 do
  begin
  ActivePage := 'sTetPanel';
  BringToFront;
  for i := 0 to ControlCount - 1 do
    Controls[i].Enabled := True;
  end;
end;

procedure TForm1.Tetris1Click (Sender: TObject);
begin
RadioButton3.Checked := True;
RadioButton14.Checked := True;
TetPanel1.State := Tetris;
Start1.Enabled := True;
Pause1.Enabled := False;
BitBtn1.Enabled := True;
Label1.Caption := '';
GroupBox8.Show;
BitBtn4.Caption := 'Rtt';
BitBtn6.Caption := 'Drp';
GroupBox7.Show;
GroupBox7.Color := clOlive;
with TabbedNoteBook1 do
  begin
  ActivePage := 'Tetris';
  for i := 0 to ControlCount - 1 do
    Controls[i].Enabled := True;
  end;
TetPanel1.BringToFront;
GroupBox10.SendToBack;
end;


procedure TForm1.About2Click (Sender: TObject);
var
PaTmp: Boolean;
begin
PaTmp := TetPanel1.Pause;
try
  if PaTmp = False then Pause1.Click;
WindowState := wsMinimized;
AboutBox := TAboutBox.Create (Application);
Aboutbox.ShowModal;
finally
  AboutBox.Free;
WindowState := wsNormal;
if PaTmp = False then Pause1.Click;
end;
end;

procedure TForm1.BitBtn1Click (Sender: TObject);
begin
Start1.Click;
end;

procedure TForm1.Start1Click (Sender: TObject);
begin
BitBtn2.Enabled := True; BitBtn1.Enabled := False;
Start1.Enabled := False; Pause1.Enabled := True;
Label1.Caption := '';
TabbedNoteBook1.SendToBack;
with TabbedNoteBook1 do
  for i := 0 to ControlCount - 1 do
    Controls[i].Enabled := False;
TetPanel1.Start := True;
end;

procedure TForm1.Pause1Click (Sender: TObject);
var
i: integer;
begin
with TetPanel1 do
  if State <> stPanel then
    if Start = True then Pause := not Pause;
with TabbedNoteBook1 do
  begin
  if TetPanel1.Pause then
    begin
    if TetPanel1.State=Tetris
    then ActivePage := 'Tetris';
      for i := 0 to ControlCount - 1 do
      Controls[i].Enabled := True;
      BringToFront;
    end
  else
    begin
    for i := 0 to ControlCount - 1 do
    Controls[i].Enabled := True;
    SendToBack;
    end;
  end;
end;

procedure TForm1.BitBtn2Click (Sender: TObject);
begin
Pause1.Click;
end;

procedure TForm1.TetPanel1TetrisOver (Sender: TObject);
begin
Start1.Enabled := True;
Pause1.Enabled := False;
BitBtn2.Enabled := False;
BitBtn1.Enabled := True;
Label1.Caption := 'Game Over!  (Scores: ' + IntToStr (TetPanel1.TScores) + ')';
with TabbedNoteBook1 do
  begin
  for i := 0 to ControlCount - 1 do
    Controls[i].Enabled := True;
  end;
GroupBox10.SendToBack;
with TetPanel1 do
  begin
  if TScores <= 30 then
    AOverPicture := 'dinner1.wmf'
  else AOverPicture := 'label1.wmf';
  end;
end;

procedure TForm1.TetPanel1TetrisContact (Sender: TObject);
begin
with TetPanel1 do
  case NexTTShape of
    1: RF1.Checked := True;
    2: RF2.Checked := True;
    3: RF3.Checked := True;
    4: RF4.Checked := True;
    5: RF5.Checked := True;
    6: RF6.Checked := True;
    7: RF7.Checked := True;
    end;
end;

procedure TForm1.TetPanel1TetrisDelete (Sender: TObject);
begin
Label1.Caption := 'You have ' + IntToStr (TetPanel1.TScores) + '  scores';
if not TetPanel1.ShowScoresTime then TetPanel1.Caption := Label1.Caption;
end;

procedure TForm1.ComboBox2Change (Sender: TObject);
begin
IdentToColor (ComboBox2.Text, tmp);
TetPanel1.ColorTF := tmp;
end;

procedure TForm1.ComboBox3Change (Sender: TObject);
begin
IdentToColor (ComboBox3.Text, tmp);
TetPanel1.ColorTB := tmp;
end;

procedure TForm1.ComboBox4Change (Sender: TObject);
begin
IdentToColor (ComboBox4.Text, tmp);
TetPanel1.ColorTShapesPen := tmp;
end;

procedure TForm1.ComboBox5Change (Sender: TObject);
begin
IdentToColor (ComboBox5.Text, tmp);
TetPanel1.OneColorTShapes := tmp;
end;

procedure TForm1.RadioButton4Click (Sender: TObject);
begin
TetPanel1.ColorTShapes := colorFixed;
end;

procedure TForm1.RadioButton5Click (Sender: TObject);
begin
TetPanel1.ColorTShapes := colorFixed2;
end;

procedure TForm1.RadioButton6Click (Sender: TObject);
begin
TetPanel1.ColorTShapes := colorOne;
end;

procedure TForm1.RadioButton7Click (Sender: TObject);
begin
TetPanel1.ColorTShapes := colorRandom;
end;

procedure TForm1.BitBtn3Click (Sender: TObject);
begin
TetPanel1.GKey := lft;
end;

procedure TForm1.BitBtn4Click (Sender: TObject);
begin
TetPanel1.GKey := rtt;
end;

procedure TForm1.BitBtn5Click (Sender: TObject);
begin
TetPanel1.GKey := rgh;
end;

procedure TForm1.BitBtn6Click (Sender: TObject);
begin
TetPanel1.GKey := drp;
end;

procedure TForm1.RadioButton8Click (Sender: TObject);
begin
TetPanel1.ShapesTBrushStyle := bsSolid;
end;

procedure TForm1.RadioButton9Click (Sender: TObject);
begin
TetPanel1.ShapesTBrushStyle := bsCross;
end;

procedure TForm1.RadioButton10Click (Sender: TObject);
begin
TetPanel1.ShapesTBrushStyle := bsBDiagonal;
end;

procedure TForm1.RadioButton11Click (Sender: TObject);
begin
TetPanel1.ShapesTShape := stRoundRect;
end;

procedure TForm1.RadioButton12Click (Sender: TObject);
begin
TetPanel1.ShapesTShape := stRectangle;
end;

procedure TForm1.RadioButton13Click (Sender: TObject);
begin
TetPanel1.ShapesTShape := stEllipse;
end;

procedure TForm1.ComboBox7Change (Sender: TObject);
begin
TetPanel1.TRows := StrToInt (ComboBox7.Text);
end;

procedure TForm1.ComboBox8Change (Sender: TObject);
begin
TetPanel1.TColumns := StrToInt (ComboBox8.Text);
end;

procedure TForm1.ComboBox9Change (Sender: TObject);
begin
TetPanel1.WidthTShapesPen := StrToInt (ComboBox9.Text);
end;

procedure TForm1.Edit1Change (Sender: TObject);
begin
TetPanel1.BStPicture := Edit1.Text;
end;

procedure TForm1.CheckBox1Click (Sender: TObject);
begin
TetPanel1.NextSColorT := CheckBox1.Checked;
end;

procedure TForm1.FormKeyDown (Sender: TObject; var Key: Word; 
  Shift: TShiftState);
begin
case Key of
  VK_F1: RF1Click (Sender);
  VK_F2: RF2Click (Sender);
  VK_F3: RF3Click (Sender);
  VK_F4: RF4Click (Sender);
  VK_F5: RF5Click (Sender);
  VK_F6: RF6Click (Sender);
  VK_F7: RF7Click (Sender);
  end;
end;

procedure TForm1.CheckBox2Click (Sender: TObject);
begin
TetPanel1.ShowScoresTime := CheckBox2.Checked;
end;

procedure TForm1.ComboBox11Change (Sender: TObject);
begin
TetPanel1.TCoeff := StrToInt (ComboBox11.Text);
end;

procedure TForm1.RF1Click (Sender: TObject);
begin
TetPanel1.NextTShape := 1;
end;

procedure TForm1.RF2Click (Sender: TObject);
begin
TetPanel1.NextTShape := 2;
end;

procedure TForm1.RF3Click (Sender: TObject);
begin
TetPanel1.NextTShape := 3;
end;

procedure TForm1.RF4Click (Sender: TObject);
begin
TetPanel1.NextTShape := 4;
end;

procedure TForm1.RF5Click (Sender: TObject);
begin
TetPanel1.NextTShape := 5;
end;

procedure TForm1.RF6Click (Sender: TObject);
begin
TetPanel1.NextTShape := 6;
end;

procedure TForm1.RF7Click (Sender: TObject);
begin
TetPanel1.NextTShape := 7;
end;

procedure TForm1.CheckBox4Click (Sender: TObject);
begin
TetPanel1.WithCaption := CheckBox4.Checked;
end;

procedure TForm1.BitBtn14Click (Sender: TObject);
begin
Exit1.Click;
end;

procedure TForm1.RadioButton20Click (Sender: TObject);
begin
TetPanel1.ShapesTBrushStyle := bsDiagCross;
end;

procedure TForm1.CheckBox6Click (Sender: TObject);
begin
TetPanel1.TimerFocus := CheckBox6.Checked;
end;

procedure TForm1.ComboBox25Change (Sender: TObject);
begin
TetPanel1.TDelay := StrToInt (ComboBox25.Text);
end;

procedure TForm1.CheckBox9Click (Sender: TObject);
begin
TetPanel1.DefKeys := CheckBox9.Checked;
end;

procedure TForm1.CheckBox3Click (Sender: TObject);
begin
TetPanel1.ShowAllDlgs := CheckBox3.Checked;
end;

procedure TForm1.CheckBox10Click (Sender: TObject);
begin
TetPanel1.PicStretch := CheckBox10.Checked;
end;

procedure TForm1.TabbedNotebook1Click (Sender: TObject);
begin
TabbedNoteBook1.BringToFront;
end;

end.
